widget_OhMyBash/forum/urls.py
from django.urls import path

from .views import (forum, ForumPostDetailView,
                    ForumPostCreateView, ForumPostUpdateView)

urlpatterns = [
    path('', forum, name='forum'),
    path('forumposts/<int:pk>/details/',
         ForumPostDetailView.as_view(),
         name='forumpost-details'),
    path('forumposts/add/',
         ForumPostCreateView.as_view(),
         name='forumpost-create'),
    path('forumposts/<int:pk>/edit/',
         ForumPostUpdateView.as_view(),
         name='forumpost-update'),
]

app_name = "forum"

widget_OhMyBash/widget_OhMyBash/urls.py
from django.contrib import admin
from django.urls import include, path

urlpatterns = [
    path('', include('dashboard.urls', namespace="dashboard")),
    path('forum/', include('forum.urls', namespace="forum")),
    path('announcements/', include('announcements.urls', namespace="announcements")),
    path('calendar/', include('widget_calendar.urls', namespace="calendar")),
    path('assignments/', include('assignments.urls', namespace="assignments")),
    path('admin/', admin.site.urls),
]

widget_OhMyBash/forum/models.py
from django.db import models
from django.urls import reverse


class ForumPost(models.Model):
    title = models.CharField(max_length=100)
    body = models.TextField()
    author = models.ForeignKey(
        'dashboard.WidgetUser',
        on_delete=models.CASCADE,
        related_name='forumpost_author'
    )
    pub_datetime = models.DateTimeField(auto_now=True)

    def __str__(self):
        return '{} by {} posted {}: {}'.format(
            self.title, 
            self.author, 
            self.pub_datetime,
            self.body
        )

    def get_absolute_url(self):
        return reverse(
            'forum:forumpost-details',
            kwargs={'pk': self.pk}
        )


class Reply(models.Model):
    body = models.TextField()
    author = models.ForeignKey(
        'dashboard.WidgetUser',
        on_delete=models.CASCADE,
        related_name='reply_author'
    )
    pub_datetime = models.DateTimeField()
    forumpost = models.ForeignKey(
        ForumPost,
        on_delete=models.CASCADE,
        related_name='forumpost_reply'
    )

    def __str__(self):
        return 'Reply by {} posted {}: {}'.format(
            self.author,
            self.pub_datetime,
            self.body,
        )

widget_OhMyBash/forum/views.py
from django.shortcuts import render
from django.views.generic.detail import DetailView
from django.views.generic.edit import CreateView, UpdateView

from .models import ForumPost, Reply


def forum(request):
    posts = ForumPost.objects.all()
    return render(request, 'forum/forum.html', {'posts': posts})


class ForumPostDetailView(DetailView):
    model = ForumPost
    template_name = 'forum/forumpost-details.html'

    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)
        context['replys'] = Reply.objects.all()
        return context


class ForumPostCreateView(CreateView):
    model = ForumPost
    fields = '__all__'
    template_name = 'forum/forumpost-add.html'


class ForumPostUpdateView(UpdateView):
    model = ForumPost
    fields = '__all__'
    template_name = 'forum/forumpost-edit.html'

widget_OhMyBash/forum/templates/forum/forum.html
{% extends 'base.html' %}
{% load static %}

{% block title %}Widget's Forum{% endblock %}

{% block heading %}<h1> Welcome to Widget's Forum! </h1>{% endblock %}

{% block content %}
<p>
    Forum Posts:<br>
    {% for post in posts|slice:"::-1" %}
    <a href="{{ post.get_absolute_url }}">
        {{ post.title }} by {{ post.author.first_name }} {{ post.author.last_name }}
    </a><br>
    {% endfor %}

</p>
{% endblock %}

{% block footing %}
<p class="centerB">
    <a href="{% url 'forum:forumpost-create' %}">
        <button class="btn add">New Post</button>
    </a>
</p>
<p><a href="/dashboard/" class="link">Dashboard</a><br>
    <a href="/announcements/" class="link">Announcements</a><br>
    <a href="/assignments/" class="link">Assignments</a><br>
    <a href="/calendar/" class="link">Calendar</a>
</p>

{% endblock %}

widget_OhMyBash/forum/templates/forum/forumpost-add.html
{% extends 'base.html' %}
{% load static %}

{% block title %}Add Post{% endblock %}

{% block heading %}<h1>Add a new post:</h1>{% endblock %}

{% block content %}
<form method="post">
    {% csrf_token %}
    {{ form.as_p }}
    <p class="centerB">
        <input class="submitB" type="submit" value="Save New Post">
    </p>
</form>
{% endblock %}

widget_OhMyBash/forum/templates/forum/forumpost-details.html
{% extends 'base.html' %}
{% load static %}

{% block title %}{{ object.title }}{% endblock %}

{% block heading %}
<h1>
    {{ object.title }}
</h1>
{% endblock %}

{% block content %}
<p>
    by {{ object.author.first_name }} {{ object.author.last_name }}<br>
    {{ object.pub_datetime|date:"m/d/Y" }}, {{ object.pub_datetime|time:"g:iA" }}<br>
    {{ object.body }}<br>
</p>
POST REPLIES:<br>
{% for reply in replys %}
{% if reply.forumpost == object %}
    by {{ reply.author.first_name }} {{ reply.author.last_name }}<br>
    {{ reply.pub_datetime|date:"m/d/Y" }}, {{ reply.pub_datetime|time:"g:iA" }}<br>
    {{ reply.body }}<br>
{% endif %}
{% endfor %}
{% endblock %}

{% block footing %}
<p class="centerB">
    <a href="{% url 'forum:forumpost-update' object.pk %}">
        <button class="btn edit">Edit Post</button>
    </a>
</p>
{% endblock %}

widget_OhMyBash/forum/templates/forum/forumpost-edit.html
{% extends 'base.html' %}
{% load static %}

{% block title %}Edit Post{% endblock %}

{% block heading %} <h1> Edit Post: </h1> {% endblock %}

{% block content %}
<form method="post">
    {% csrf_token %}
    {{ form.as_p }}
    <p class="centerB">
        <input class="submitB "type="submit" value="Save Changes to Post">
    </p>
</form>
{% endblock %}